#!/bin/sh -efu

a= . install2-init-functions
. shell-quote

ldm_gtk_first_user()
{
	local ft_script=/etc/firsttime.d/80-lightdm-gtk-first-user
	local ldm_state_dir=/var/lib/ldm/.cache/lightdm-gtk-greeter

    [ -e "$destdir/usr/sbin/lightdm-gtk-greeter" ] || return 0
    cat >>"$destdir$ft_script" <<FIRSTTIME
#!/bin/sh -efu

_cleanup_handler()
{
    local rc=\$?
    trap - EXIT
    rm $ft_script
    exit \$rc
}

trap _cleanup_handler EXIT HUP PIPE INT QUIT TERM

uid_min= user=

if [ -s $ldm_state_dir/state ]; then
    exit 0
fi

uid_min="\$(sed -rn  's/^UID_MIN[[:blank:]]+([[:digit:]]+)[[:blank:]]*$/\1/p' /etc/login.defs)"
[ -n "\$uid_min" ] || return 0

user="\$(getent passwd "\$uid_min" | cut -f1 -d:)"
[ -n "\$user" ] || exit 0

mkdir -p $ldm_state_dir

cat >>$ldm_state_dir/state <<EOF
[greeter]
last-user=\$user
EOF

chown -R _ldm:_ldm /var/lib/ldm/
FIRSTTIME

	chmod +x "$destdir$ft_script"
}

ldm_gtk_setup()
{
	local greeter_conf="$destdir/etc/lightdm/lightdm-gtk-greeter.conf"
	local branding_conf="$destdir/usr/share/install3/lightdm-gtk-greeter.conf"
	local l= k= v= rp=
	[ -e "$greeter_conf" ] || return 0
	[ -e "$branding_conf" ] || return 0
	while read l; do
		k="${l%%=*}"
		# Skip comments
		[ -n "${k###*}" ] || continue

		v="${l#*=}"
		quote_sed_regexp_variable rp "$k=$v"
		sed -r -i "s|^#?$k=.*|$rp|" "$greeter_conf"
	done <"$branding_conf"
}

####

# Set first user to display in lightdm-gtk-greeter by default
ldm_gtk_first_user

# Setup lightdm-gtk-greeter if needed
ldm_gtk_setup
